%define major     12
%define libqs4    %mklibname qscintilla2_ %{major}
%define libqs5    %mklibname qscintilla2-qt5_ %{major}
%define libqs4dev %mklibname qscintilla2 -d
%define libqs5dev %mklibname qscintilla2-qt5 -d

Name:           qscintilla
Version:        2.9.1
Release:        %mkrel 2
Summary:        Port to Qt of Neil Hodgson's Scintilla C++ editor class
License:        GPLv2+
Group:          System/Libraries
URL:            http://www.riverbankcomputing.co.uk/software/qscintilla/intro
Source0:        http://downloads.sourceforge.net/pyqt/QScintilla-gpl-%{version}.tar.xz
Patch0:         QScintilla-gpl-2.9.1-qt5.patch

BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(phonon)
BuildRequires:  sed

# Qt4/Qt5
BuildRequires:  qt4-devel
BuildRequires:  pkgconfig(QtWebKit)
BuildRequires:  pkgconfig(Qt5Widgets)
BuildRequires:  pkgconfig(Qt5PrintSupport)
BuildRequires:  pkgconfig(Qt5Designer)

# Python 2
BuildRequires:  pkgconfig(python2)
BuildRequires:  pkgconfig(dbus-python)
BuildRequires:  python-qt4-devel
BuildRequires:  python-qt5-devel
BuildRequires:  python-sip

# Python 3
BuildRequires:  pkgconfig(python3)
BuildRequires:  python3-dbus
BuildRequires:  python3-qt5-devel
BuildRequires:  python3-sip-devel

%description
As well as features found in standard text editing components,
QScintilla includes features especially useful when editing and
debugging source code. These include support for syntax styling, error
indicators, code completion and call tips. The selection margin can
contain markers like those used in debuggers to indicate breakpoints
and the current line. Styling choices are more open than with many
editors, allowing the use of proportional fonts, bold and italics,
multiple foreground and background colours and multiple fonts.

#--------------------------------------------------------------

%package -n     %{libqs4}
Summary:        Port to Qt4 of Neil Hodgson's Scintilla C++ editor class
Group:          System/Libraries
#Obsoletes:      libqscintilla-qt4_2


%description -n %{libqs4}
As well as features found in standard text editing components,
QScintilla includes features especially useful when editing and
debugging source code. These include support for syntax styling, error
indicators, code completion and call tips. The selection margin can
contain markers like those used in debuggers to indicate breakpoints
and the current line. Styling choices are more open than with many
editors, allowing the use of proportional fonts, bold and italics,
multiple foreground and background colours and multiple fonts.

%files -n %{libqs4}
%{_qt4_libdir}/libqscintilla2.so.%{major}
%{_qt4_libdir}/libqscintilla2.so.%{major}.*
%{_qt4_translationdir}/qscintilla*.qm

#--------------------------------------------------------------

%package -n     %{libqs5}
Summary:        Port to Qt5 of Neil Hodgson's Scintilla C++ editor class
Group:          System/Libraries

%description -n %{libqs5}
As well as features found in standard text editing components,
QScintilla includes features especially useful when editing and
debugging source code. These include support for syntax styling, error
indicators, code completion and call tips. The selection margin can
contain markers like those used in debuggers to indicate breakpoints
and the current line. Styling choices are more open than with many
editors, allowing the use of proportional fonts, bold and italics,
multiple foreground and background colours and multiple fonts.

%files -n %{libqs5}
%{_qt5_libdir}/libqscintilla2-qt5.so.%{major}
%{_qt5_libdir}/libqscintilla2-qt5.so.%{major}.*
%{_qt5_translationdir}/qscintilla*.qm

#--------------------------------------------------------------

%package -n     %{libqs5dev}
Summary:        Libraries, include and other files to develop applications with QScintilla for Qt5
Group:          Development/Libraries
Requires:       %{libqs5} = %{version}-%{release}
Provides:       %{name}-qt5-devel = %{version}-%{release}

%description -n %{libqs5dev}
This packages contains the libraries, include and other files
you can use to develop applications with QScintilla.

%files -n %{libqs5dev}
%{_qt5_includedir}/*
%{_qt5_libdir}/libqscintilla2-qt5.so
%{_qt5_prefix}/mkspecs/features/qscintilla2.prf
%{_qt5_plugindir}/designer/*

#--------------------------------------------------------------

%package -n     %{libqs4dev}
Summary:        Libraries, include and other files to develop applications with QScintilla for Qt4
Group:          Development/Libraries
Requires:       %{libqs4} = %{version}-%{release}
Provides:       %{name}-qt4-devel = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
Provides:       %{_lib}qscintilla-devel = %{version}-%{release}
#Obsoletes:      %{_lib}qscintilla-qt4-devel
Provides:       %{_lib}qscintilla-qt4-devel = %{version}-%{release}

%description -n %{libqs4dev}
This packages contains the libraries, include and other files
you can use to develop applications with QScintilla.

%files -n %{libqs4dev}
%{_includedir}/Qsci
%{_qt4_prefix}/mkspecs/features/qscintilla2.prf
%{_qt4_libdir}/libqscintilla2.so
%{_qt4_plugindir}/designer/libqscintillaplugin.so

#--------------------------------------------------------------

%package -n     python3-qt5-qscintilla
Summary:        Python3 Qt5 QScintilla bindings
Group:          Development/Python
Requires:       python3-qt5
Requires:       sip-api(%{_sip_api_major}) >= %{_sip_api}
Requires:       %{libqs5} = %{version}

%description -n python3-qt5-qscintilla
Python3 Qt5 QScintilla bindings.

%files -n python3-qt5-qscintilla 
%{_datadir}/python3-sip/PyQt5/Qsci
%{python3_sitearch}/PyQt5/Qsci.so

#--------------------------------------------------------------

%package -n     python3-qt4-qscintilla
Summary:        Python3 Qt4 QScintilla bindings
Group:          Development/Python
Requires:       python3-qt4
Requires:       sip-api(%{_sip_api_major}) >= %{_sip_api}
Requires:       %{libqs4} = %{version}

%description -n python3-qt4-qscintilla
Python3 Qt4 QScintilla bindings.

%files -n python3-qt4-qscintilla
%{_datadir}/python3-sip/PyQt4/Qsci
%{python3_sitearch}/PyQt4/Qsci.so

#--------------------------------------------------------------

%package -n     python-qt5-qscintilla
Summary:        Python Qt5 QScintilla bindings
Group:          Development/Python
Requires:       python-qt5
Requires:       sip-api(%{_sip_api_major}) >= %{_sip_api}
Requires:       %{libqs5} = %{version}

%description -n python-qt5-qscintilla
Python2 Qt5 QScintilla bindings.

%files -n python-qt5-qscintilla
%{_datadir}/sip/PyQt5/Qsci
%{python2_sitearch}/PyQt5/Qsci.so

#--------------------------------------------------------------

%package -n     python-qt4-qscintilla
Summary:        Python Qt4 QScintilla bindings
Group:          Development/Python
Requires:       python-qt4
Requires:       sip-api(%{_sip_api_major}) >= %{_sip_api}
Requires:       %{libqs4} = %{version}

%description -n python-qt4-qscintilla
Python2 Qt4 QScintilla bindings.

%files -n python-qt4-qscintilla
%{_datadir}/sip/PyQt4/Qsci
%{python2_sitearch}/PyQt4/Qsci.so

#--------------------------------------------------------------

%package        doc-qt5
Summary:        QScintilla docs
Group:          Documentation
BuildArch:      noarch

%description    doc-qt5
QScintilla doc.

%files doc-qt5
%doc NEWS README doc
%{_qt5_prefix}/qsci/api/python/*

#--------------------------------------------------------------

%package        doc
Summary:        QScintilla docs
Group:          Documentation
BuildArch:      noarch

%description    doc
QScintilla doc.

%files doc
%{_qt4_prefix}/qsci/api/python/*

#--------------------------------------------------------------

%prep 
%setup -qn QScintilla-gpl-%{version}
%patch0 -p1 -b .qt5

%build
### Qt4 build
PATH=%{_qt4_bindir}:$PATH; export PATH

cp -a Qt4Qt5 Qt4/
pushd Qt4
	%{qmake_qt4} qscintilla.pro
	%make
popd

# set QMAKEFEATURES to ensure just built lib/feature is found
QMAKEFEATURES=`pwd`/Qt4/features; export QMAKEFEATURES

cp -a designer-Qt4Qt5 designer-Qt4/
pushd designer-Qt4
	%{qmake_qt4} designer.pro INCLUDEPATH+=../Qt4 LIBS+=-L../Qt4
	%make
popd

cp -a Python Python2-qt4
pushd Python2-qt4
	%{__python2} \
  		configure.py \
    		--no-timestamp \
    		--qsci-incdir=../Qt4 --qsci-libdir=../Qt4

	%make
popd

cp -a Python Python3-qt4
pushd Python3-qt4
	%{__python3} \
  		configure.py \
    		--no-timestamp \
    		--pyqt-sipdir=/usr/share/python3-sip/PyQt4 \
    		--qsci-incdir=../Qt4 --qsci-libdir=../Qt4 \
    		--sip=/usr/bin/python3-sip

	%make
popd

### Qt5 build
PATH=%{_qt5_bindir}:$PATH; export PATH

cp -a Qt4Qt5 Qt5/
pushd Qt5
	%{qmake_qt5} qscintilla.pro
	%make
popd

# set QMAKEFEATURES to ensure just built lib/feature is found
QMAKEFEATURES=`pwd`/Qt5/features; export QMAKEFEATURES

cp -a designer-Qt4Qt5 designer-Qt5/
pushd designer-Qt5
	%{qmake_qt5} designer.pro INCLUDEPATH+=../Qt5 LIBS+=-L../Qt5
	%make
popd

cp -a Python Python2-qt5
pushd Python2-qt5
	%{__python2} \
  		configure.py \
    		--no-timestamp \
    		--pyqt=PyQt5 \
    		--qsci-incdir=../Qt5 --qsci-libdir=../Qt5

	%make
popd

cp -a Python Python3-qt5
pushd Python3-qt5
	%{__python3} \
  		configure.py \
    		--no-timestamp \
    		--pyqt=PyQt5 \
    		--pyqt-sipdir=/usr/share/python3-sip/PyQt5 \
    		--qsci-incdir=../Qt5 --qsci-libdir=../Qt5 \
    		--sip=/usr/bin/python3-sip

	%make
popd

%install
### Qt4 install
make -C Qt4 install INSTALL_ROOT=%{buildroot}
make -C designer-Qt4 install INSTALL_ROOT=%{buildroot}

make -C Python2-qt4 install DESTDIR=%{buildroot} INSTALL_ROOT=%{buildroot}
test -x   %{buildroot}%{python2_sitearch}/PyQt4/Qsci.so || \
chmod a+x %{buildroot}%{python2_sitearch}/PyQt4/Qsci.so
make -C Python3-qt4 install DESTDIR=%{buildroot} INSTALL_ROOT=%{buildroot}
test -x   %{buildroot}%{python3_sitearch}/PyQt4/Qsci.so || \
chmod a+x %{buildroot}%{python3_sitearch}/PyQt4/Qsci.so

### Qt5 install
make -C Qt5 install INSTALL_ROOT=%{buildroot}
make -C designer-Qt5 install INSTALL_ROOT=%{buildroot}

make -C Python2-qt5 install DESTDIR=%{buildroot} INSTALL_ROOT=%{buildroot}
test -x   %{buildroot}%{python2_sitearch}/PyQt5/Qsci.so || \
chmod a+x %{buildroot}%{python2_sitearch}/PyQt5/Qsci.so
make -C Python3-qt5 install DESTDIR=%{buildroot} INSTALL_ROOT=%{buildroot}
test -x   %{buildroot}%{python3_sitearch}/PyQt5/Qsci.so || \
chmod a+x %{buildroot}%{python3_sitearch}/PyQt5/Qsci.so


%changelog
* Tue Jan 30 2018 adrianomorselli <adrianomorselli> 2.9.1-2uplos2018
- new version to fix octave
